# A cover viewer plugin

import copy
import xml.parsers.expat
import urllib
import gtk, gtk.glade
import pygtk
import threading
import os

COVER_PATH = os.path.expanduser("~/.pympd/covers/")

class Result:
    asin = ''
    productname = ''
    catalog = ''
    artists = []
    releasedate = ''
    manafacturer = ''
    imageurlsmall = ''
    imageurlmedium = ''
    imageurllarge = ''

class Parser:
    results = []
    result = Result()
    attr = ''
    def start_element(self, name, attrs):
        pass
    def end_element(self, name):
        if name.lower() == 'details':
            result_open = False
            self.results.append(copy.deepcopy(self.result))
        setattr(self.result, name.lower(), self.attr)
    def char_data(self, data):
        self.attr = data

class Coverviewer:

    # called when we load the plugin. we get passed the mainWindow, plugin menu
    # item as well as a connection to mpd.
    def _init(self, data):
        if not os.path.exists(os.path.expanduser("~/.pympd/covers")):
            print 'Creating coverart directory'
            os.mkdir(os.path.expanduser('~/.pympd/covers'))
        self.mainWindow, self.pluginMenu, self.pympd, self.base_dir = data
        self.buildPluginMenu(self.pluginMenu)
        self.buildInfoWindow()
        self.urlfile = urllib.URLopener()
        self.r = Parser()
        self.CVurl = "http://xml.amazon.com/onca/xml3?t=webservices-20&dev-t=1SR4P88NA1BQ5RZVWK02"
        self.displayedImage = None

    # plugin configure dialog.
    def _conf(self, hasDialog=None):
        return False
    
    # update plugin, data is of type mpdclient.Status
    def _spin(self, data, songChanged=False):
        if songChanged and self.dialogWindow.get_property('visible'):
            self.browseCovers(None)
        pass

    # called on plugin unloaded
    def _unload(self):
        self.pluginMenuEntry.destroy()
        self.dialogWindow.destroy()
        return

    # callback for find similar artists in menu
    def browseCovers(self, obj):
        song = self.pympd.getCurrentSong()
        if not song == False:
            search_term = song.artist + ' - ' + song.album
            thread =threading.Thread(target=self.OpenURL, args=[search_term])
            thread.start()
        

    def OpenURL(self, search_term):
        gtk.threads_enter()
        self.dialogWindow.show_all()
        gtk.threads_leave()
        file = self.urlfile.open("%s&KeywordSearch=%s&mode=music&type=lite&page=1&f=xml" % (self.CVurl, search_term.replace(' ', '%20')))
        lines = file.readlines()
        data = ''
        for line in lines:
            data += line
        #make a new parser for ourselves
        self.newParser()
        self.parser.Parse(data)
        file.close()
        self.urlfile.close()

        if len(self.r.results) > 0:
            self.dispImage(self.r.results[0].imageurllarge)
    
    #TODO: when loading a cached image when the same image is being displayed, we get in a little trouble.
    def dispImage(self, imageurl):
        image_name = imageurl[imageurl.rfind('/')+1:]
        image_path = COVER_PATH + image_name
        if self.displayedImage == image_path:
            return
        if os.path.exists(image_path):
            print "Cached copy found"
        else:
            self.urlfile.retrieve(imageurl, image_path)[0]
            print "Retrieving image from web"
        gtk.threads_enter()
        self.image.set_from_file(None)
        self.image.set_from_file(image_path)
        self.image.show()
        gtk.threads_leave()
        self.displayedImage = image_path
        

    def newParser(self):
        self.r.results = []
        self.parser = xml.parsers.expat.ParserCreate()
        self.parser.StartElementHandler = self.r.start_element
        self.parser.EndElementHandler = self.r.end_element
        self.parser.CharacterDataHandler = self.r.char_data
    
    
    # Init Functions
    def buildPluginMenu(self, pluginMenu):
        self.pluginMenuEntry = gtk.MenuItem('Cover Viewer')
        pluginSubMenu = gtk.Menu()
        pluginSubMenu.set_title('Coverviewer')
        menuEntry = gtk.MenuItem('Show Album Covers')
        menuEntry.connect('activate', self.browseCovers)
        pluginSubMenu.append(menuEntry)
        self.pluginMenuEntry.set_submenu(pluginSubMenu)
        self.pluginMenuEntry.show_all()
        pluginMenu.append(self.pluginMenuEntry)

    def buildInfoWindow(self):
        self.xml = gtk.glade.XML("%s/glade/coverviewer.glade"%self.base_dir)
        self.dialogWindow = self.xml.get_widget("dialog1")
        self.image = self.xml.get_widget("image1")

        dic = {"on_dialog_closed" : self.close_dialog }
        self.xml.signal_autoconnect(dic)

    def close_dialog(self, obj, data):
        self.dialogWindow.hide()
        return True
